
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Home_sectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        section_type: data.section_type
        ||
        null
            ,
            
        subtitle: data.subtitle
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_enabled: data.is_enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        
        await home_sections.setFeatured_services(data.featured_services || [], {
            transaction,
        });
        
        await home_sections.setFeatured_projects(data.featured_projects || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.home_sections.getTableName(),
                belongsToColumn: 'background_images',
                belongsToId: home_sections.id,
            },
            data.background_images,
            options,
        );
        

        return home_sections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const home_sectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                section_type: item.section_type
            ||
            null
            ,
            
                subtitle: item.subtitle
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_enabled: item.is_enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const home_sections = await db.home_sections.bulkCreate(home_sectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < home_sections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.home_sections.getTableName(),
                    belongsToColumn: 'background_images',
                    belongsToId: home_sections[i].id,
                },
                data[i].background_images,
                options,
            );
        }
        

        return home_sections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const home_sections = await db.home_sections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.section_type !== undefined) updatePayload.section_type = data.section_type;
        
        
        if (data.subtitle !== undefined) updatePayload.subtitle = data.subtitle;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_enabled !== undefined) updatePayload.is_enabled = data.is_enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await home_sections.update(updatePayload, {transaction});

        
        

        
        
        if (data.featured_services !== undefined) {
            await home_sections.setFeatured_services(data.featured_services, { transaction });
        }
        
        if (data.featured_projects !== undefined) {
            await home_sections.setFeatured_projects(data.featured_projects, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.home_sections.getTableName(),
                belongsToColumn: 'background_images',
                belongsToId: home_sections.id,
            },
            data.background_images,
            options,
        );
        

        return home_sections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of home_sections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of home_sections) {
                await record.destroy({transaction});
            }
        });


        return home_sections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.findByPk(id, options);

        await home_sections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await home_sections.destroy({
            transaction
        });

        return home_sections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.findOne(
            { where },
            { transaction },
        );

        if (!home_sections) {
            return home_sections;
        }

        const output = home_sections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.background_images = await home_sections.getBackground_images({
            transaction
        });
        
        
        output.featured_services = await home_sections.getFeatured_services({
            transaction
        });
        
        
        output.featured_projects = await home_sections.getFeatured_projects({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [


      {
        model: db.services,
        as: 'featured_services',
        required: false,
      },

      {
        model: db.projects,
        as: 'featured_projects',
        required: false,
      },


      {
        model: db.file,
        as: 'background_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'home_sections',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.subtitle) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'home_sections',
                        'subtitle',
                        filter.subtitle,
                    ),
                };
            }
            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'home_sections',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.section_type) {
                where = {
                    ...where,
                section_type: filter.section_type,
            };
            }
            
            if (filter.is_enabled) {
                where = {
                    ...where,
                is_enabled: filter.is_enabled,
            };
            }
            



      if (filter.featured_services) {
        const searchTerms = filter.featured_services.split('|');

        include = [
          {
            model: db.services,
            as: 'featured_services_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }

      if (filter.featured_projects) {
        const searchTerms = filter.featured_projects.split('|');

        include = [
          {
            model: db.projects,
            as: 'featured_projects_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  title: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.home_sections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'home_sections',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.home_sections.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

